diff --git a/src/ps2port.c b/src/ps2port.c
index 58335af..6385429 100644
--- a/src/ps2port.c
+++ b/src/ps2port.c
@@ -19,8 +19,7 @@
 
 // Timeout value.
 #define I8042_CTL_TIMEOUT       10000
-
-#define I8042_BUFFER_SIZE       16
+#define I8042_FLUSH_TIMEOUT     300
 
 static int
 i8042_wait_read(void)
@@ -57,7 +56,7 @@ i8042_flush(void)
 {
     dprintf(7, "i8042_flush\n");
     int i;
-    for (i=0; i<I8042_BUFFER_SIZE; i++) {
+    for (i=0; i<I8042_FLUSH_TIMEOUT; i++) {
         u8 status = inb(PORT_PS2_STATUS);
         if (! (status & I8042_STR_OBF))
             return 0;
